function d = DesiredDepths(D, w)
    % D is the typical depth we work at
    % w is a vector containing the results of the computation of W on all
    %   the points of the cloud.
    W = sum(w);
    d = D + log(w / W)/log(2); % we work on "curves", of Haussdorf dimension 1 --> log(2^1) instead of log(2^2).
end