clear all;
close all;

ech = 0.4;
x = -2:ech:10;
xconvo = -1.5:ech:1.5;
convo = arrayfun(@order2BSpline, xconvo);
ind = (3 <= x) & (x <= 7);
ind = ind*1;

indconvo = conv(ind, convo, 'same')*ech;
indconvop = [0, (indconvo(2:end) - indconvo(1:(end-1)))/ech ];

figure(1);
hold on;
plot(x, ind, xconvo, convo);
plot([0,0], [-5,5], 'k');
axis equal;

grid on;
hold off;

figure(2);
hold on;
plot(x, ind, xconvo, convo, x, indconvo, 'k');
plot([0,0], [-5,5], 'k');
axis equal;

grid on;
hold off;

figure(3);
axis on;
hold on;
plot([0,0], [-5,5], 'k');
plot(x, ind, xconvo, convo, x, indconvo, 'k');
plot(x, indconvop, '-r');
axis equal;

grid on;
hold off;


% Reconstruction

figure(4);
axis on;
hold on;
plot([0,0], [-5,5], 'k');
plot([-2,10], [0,0], 'k');
scatter([3,7], [0,0]);
stem([3,7], [1, -1], '-g');

axis equal;

grid on;
hold off;


figure(5);
axis on;
hold on;
plot([0,0], [-5,5], 'k');
plot([-2,10], [0,0], 'k');
scatter([3,7], [0,0]);
stem([3,7], [1, -1], '-g');
plot(x, indconvop, '-r');

axis equal;

grid on;
hold off;


figure(6);
axis on;
hold on;
plot([0,0], [-5,5], 'k');
plot([-2,10], [0,0], 'k');
scatter([3,7], [0,0]);
stem([3,7], [1, -1], '-g');
plot(x, indconvop, '-r');
plot(x, indconvo, 'k');
axis equal;

grid on;
hold off;


figure(7);
axis on;
hold on;
plot([0,0], [-5,5], 'k');
plot([-2,10], [0,0], 'k');
scatter([3,7], [0,0]);
stem([3,7], [1, -1], '-g');
plot(x, indconvop, '-r');
plot(x, indconvo, '-k');
plot([-2,10], [0.5,0.5], '-c');
plot([3,3], [0,0.5], '-.c');
plot([7,7], [0,0.5], '-.c');
plot([3,7], [0,0], '-c', 'Linewidth', 2);
axis equal;

grid on;
hold off;

