close all;
clear all;

ti = 0:0.01:2.5;
ti = ti';
ti = ti(2:end);

P = [cos(ti.^2), sin(ti.^2)];
P = P/3 + 0.5;

T = QuadTree(P, []);
figure(1);
hold on;
scatter(P(:,1), P(:,2));
T.plot();

l = 1:numel(ti);
% W is computed at depth 3 !
w_p = arrayfun(@(x) W(P, T, 3, x), l);
stem3(P(:,1), P(:,2), w_p);

axis([0,1, 0, 1]);
axis square;
hold off;

figure(2);
hold on;
scatter(P(:,1), P(:,2));
T.plot();

l = 1:numel(ti);
d = DesiredDepths(T.getMaxDepth(), w_p);
plot3(P(:,1), P(:,2), d);

axis([0,1, 0, 1]);
axis square;
hold off;

